/*
  Name: aG1_EffectiveGL.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G1 - some OpenGL betterups
*/

#include "aG1_EffectiveGL.hpp"

__fastcall Aegis::G1::PushMatrixObjectf::PushMatrixObjectf() {
    b = false;
    
    glGetError(); // clear error flag
    glPushMatrix();
    
    if (glGetError() == GL_STACK_OVERFLOW) {
        b = true;

        int mode;
        glGetIntegerv( GL_MATRIX_MODE, &mode );
        
        switch(mode) {
            case GL_MODELVIEW:
                glGetFloatv( GL_MODELVIEW_MATRIX, m );
            break;
            case GL_PROJECTION:
                glGetFloatv( GL_PROJECTION_MATRIX, m );
            break;
            case GL_TEXTURE:
                glGetFloatv( GL_TEXTURE_MATRIX, m );
            break;
        };
    };
    
    return;
};
__fastcall Aegis::G1::PushMatrixObjectf::~PushMatrixObjectf() {
    if (b)
        glLoadMatrixf( m );
    else
        glPopMatrix();
    return;
};


