/*
  Name: aG1_Extensions.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G1 - OpenGL Extensions
*/

#include "aG1_Extension.hpp"
#include "../../Attribs.hpp"
        
// Exported function pointers
void SafeCall(...) __noreturn;

// Extension class
Aegis::G1::Extension::Extension() {
    glActiveTextureARB    = (PFNGLACTIVETEXTUREARBPROC) SafeCall;
    glClientActiveTextureARB = (PFNGLCLIENTACTIVETEXTUREARBPROC) SafeCall;
    glMultiTexCoord1dARB  = (PFNGLMULTITEXCOORD1DARBPROC ) SafeCall;
    glMultiTexCoord1dvARB = (PFNGLMULTITEXCOORD1DVARBPROC) SafeCall;
    glMultiTexCoord1fARB  = (PFNGLMULTITEXCOORD1FARBPROC ) SafeCall;
    glMultiTexCoord1fvARB = (PFNGLMULTITEXCOORD1FVARBPROC) SafeCall;
    glMultiTexCoord1iARB  = (PFNGLMULTITEXCOORD1IARBPROC ) SafeCall;
    glMultiTexCoord1ivARB = (PFNGLMULTITEXCOORD1IVARBPROC) SafeCall;
    glMultiTexCoord1sARB  = (PFNGLMULTITEXCOORD1SARBPROC ) SafeCall;
    glMultiTexCoord1svARB = (PFNGLMULTITEXCOORD1SVARBPROC) SafeCall;
    glMultiTexCoord2dARB  = (PFNGLMULTITEXCOORD2DARBPROC ) SafeCall;
    glMultiTexCoord2dvARB = (PFNGLMULTITEXCOORD2DVARBPROC) SafeCall;
    glMultiTexCoord2fARB  = (PFNGLMULTITEXCOORD2FARBPROC ) SafeCall;
    glMultiTexCoord2fvARB = (PFNGLMULTITEXCOORD2FVARBPROC) SafeCall;
    glMultiTexCoord2iARB  = (PFNGLMULTITEXCOORD2IARBPROC ) SafeCall;
    glMultiTexCoord2ivARB = (PFNGLMULTITEXCOORD2IVARBPROC) SafeCall;
    glMultiTexCoord2sARB  = (PFNGLMULTITEXCOORD2SARBPROC ) SafeCall;
    glMultiTexCoord2svARB = (PFNGLMULTITEXCOORD2SVARBPROC) SafeCall;
    glMultiTexCoord3dARB  = (PFNGLMULTITEXCOORD3DARBPROC ) SafeCall;
    glMultiTexCoord3dvARB = (PFNGLMULTITEXCOORD3DVARBPROC) SafeCall;
    glMultiTexCoord3fARB  = (PFNGLMULTITEXCOORD3FARBPROC ) SafeCall;
    glMultiTexCoord3fvARB = (PFNGLMULTITEXCOORD3FVARBPROC) SafeCall;
    glMultiTexCoord3iARB  = (PFNGLMULTITEXCOORD3IARBPROC ) SafeCall;
    glMultiTexCoord3ivARB = (PFNGLMULTITEXCOORD3IVARBPROC) SafeCall;
    glMultiTexCoord3sARB  = (PFNGLMULTITEXCOORD3SARBPROC ) SafeCall;
    glMultiTexCoord3svARB = (PFNGLMULTITEXCOORD3SVARBPROC) SafeCall;
    glMultiTexCoord4dARB  = (PFNGLMULTITEXCOORD4DARBPROC ) SafeCall;
    glMultiTexCoord4dvARB = (PFNGLMULTITEXCOORD4DVARBPROC) SafeCall;
    glMultiTexCoord4fARB  = (PFNGLMULTITEXCOORD4FARBPROC ) SafeCall;
    glMultiTexCoord4fvARB = (PFNGLMULTITEXCOORD4FVARBPROC) SafeCall;
    glMultiTexCoord4iARB  = (PFNGLMULTITEXCOORD4IARBPROC ) SafeCall;
    glMultiTexCoord4ivARB = (PFNGLMULTITEXCOORD4IVARBPROC) SafeCall;
    glMultiTexCoord4sARB  = (PFNGLMULTITEXCOORD4SARBPROC ) SafeCall;
    glMultiTexCoord4svARB = (PFNGLMULTITEXCOORD4SVARBPROC) SafeCall;
    
    
    glSecondaryColor3bEXT      = (PFNGLSECONDARYCOLOR3BEXTPROC     ) SafeCall;
    glSecondaryColor3bvEXT     = (PFNGLSECONDARYCOLOR3BVEXTPROC    ) SafeCall;
    glSecondaryColor3dEXT      = (PFNGLSECONDARYCOLOR3DEXTPROC     ) SafeCall;
    glSecondaryColor3dvEXT     = (PFNGLSECONDARYCOLOR3DVEXTPROC    ) SafeCall;
    glSecondaryColor3fEXT      = (PFNGLSECONDARYCOLOR3FEXTPROC     ) SafeCall;
    glSecondaryColor3fvEXT     = (PFNGLSECONDARYCOLOR3FVEXTPROC    ) SafeCall;
    glSecondaryColor3iEXT      = (PFNGLSECONDARYCOLOR3IEXTPROC     ) SafeCall;
    glSecondaryColor3ivEXT     = (PFNGLSECONDARYCOLOR3IVEXTPROC    ) SafeCall;
    glSecondaryColor3sEXT      = (PFNGLSECONDARYCOLOR3SEXTPROC     ) SafeCall;
    glSecondaryColor3svEXT     = (PFNGLSECONDARYCOLOR3SVEXTPROC    ) SafeCall;
    glSecondaryColor3ubEXT     = (PFNGLSECONDARYCOLOR3UBEXTPROC    ) SafeCall;
    glSecondaryColor3ubvEXT    = (PFNGLSECONDARYCOLOR3UBVEXTPROC   ) SafeCall;
    glSecondaryColor3uiEXT     = (PFNGLSECONDARYCOLOR3UIEXTPROC    ) SafeCall;
    glSecondaryColor3uivEXT    = (PFNGLSECONDARYCOLOR3UIVEXTPROC   ) SafeCall;
    glSecondaryColor3usEXT     = (PFNGLSECONDARYCOLOR3USEXTPROC    ) SafeCall;
    glSecondaryColor3usvEXT    = (PFNGLSECONDARYCOLOR3USVEXTPROC   ) SafeCall;
    glSecondaryColorPointerEXT = (PFNGLSECONDARYCOLORPOINTEREXTPROC) SafeCall;
    
    glBlendColorEXT = (PFNGLBLENDCOLOREXTPROC) SafeCall;
    
    glBlendEquationEXT = (PFNGLBLENDEQUATIONEXTPROC) SafeCall;
    
    glLockArraysEXT   = (PFNGLLOCKARRAYSEXTPROC  ) SafeCall;
    glUnlockArraysEXT = (PFNGLUNLOCKARRAYSEXTPROC) SafeCall;
    
    glDrawRangeElementsEXT = (PFNGLDRAWRANGEELEMENTSEXTPROC) SafeCall;
    
    glFogCoordfEXT       = (PFNGLFOGCOORDFEXTPROC      ) SafeCall;
    glFogCoordfvEXT      = (PFNGLFOGCOORDFVEXTPROC     ) SafeCall;
    glFogCoorddEXT       = (PFNGLFOGCOORDDEXTPROC      ) SafeCall;
    glFogCoorddvEXT      = (PFNGLFOGCOORDDVEXTPROC     ) SafeCall;
    glFogCoordPointerEXT = (PFNGLFOGCOORDPOINTEREXTPROC) SafeCall;
    
    glCompressedTexImage3DARB     = (PFNGLCOMPRESSEDTEXIMAGE3DARBPROC   ) SafeCall;
    glCompressedTexImage2DARB     = (PFNGLCOMPRESSEDTEXIMAGE2DARBPROC   ) SafeCall;
    glCompressedTexImage1DARB     = (PFNGLCOMPRESSEDTEXIMAGE1DARBPROC   ) SafeCall;
    glCompressedTexSubImage3DARB  = (PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC) SafeCall;
    glCompressedTexSubImage2DARB  = (PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC) SafeCall;
    glCompressedTexSubImage1DARB  = (PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC) SafeCall;
    glGetCompressedTexImageARB    = (PFNGLGETCOMPRESSEDTEXIMAGEARBPROC  ) SafeCall;
    
    glVertexAttrib1sARB             = (PFNGLVERTEXATTRIB1SARBPROC            ) SafeCall;
    glVertexAttrib1fARB             = (PFNGLVERTEXATTRIB1FARBPROC            ) SafeCall;
    glVertexAttrib1dARB             = (PFNGLVERTEXATTRIB1DARBPROC            ) SafeCall;
    glVertexAttrib2sARB             = (PFNGLVERTEXATTRIB2SARBPROC            ) SafeCall;
    glVertexAttrib2fARB             = (PFNGLVERTEXATTRIB2FARBPROC            ) SafeCall;
    glVertexAttrib2dARB             = (PFNGLVERTEXATTRIB2DARBPROC            ) SafeCall;
    glVertexAttrib3sARB             = (PFNGLVERTEXATTRIB3SARBPROC            ) SafeCall;
    glVertexAttrib3fARB             = (PFNGLVERTEXATTRIB3FARBPROC            ) SafeCall;
    glVertexAttrib3dARB             = (PFNGLVERTEXATTRIB3DARBPROC            ) SafeCall;
    glVertexAttrib4sARB             = (PFNGLVERTEXATTRIB4SARBPROC            ) SafeCall;
    glVertexAttrib4fARB             = (PFNGLVERTEXATTRIB4FARBPROC            ) SafeCall;
    glVertexAttrib4dARB             = (PFNGLVERTEXATTRIB4DARBPROC            ) SafeCall;
    glVertexAttrib4NubARB           = (PFNGLVERTEXATTRIB4NUBARBPROC          ) SafeCall;
    glVertexAttrib1svARB            = (PFNGLVERTEXATTRIB1SVARBPROC           ) SafeCall;
    glVertexAttrib1fvARB            = (PFNGLVERTEXATTRIB1FVARBPROC           ) SafeCall;
    glVertexAttrib1dvARB            = (PFNGLVERTEXATTRIB1DVARBPROC           ) SafeCall;
    glVertexAttrib2svARB            = (PFNGLVERTEXATTRIB2SVARBPROC           ) SafeCall;
    glVertexAttrib2fvARB            = (PFNGLVERTEXATTRIB2FVARBPROC           ) SafeCall;
    glVertexAttrib2dvARB            = (PFNGLVERTEXATTRIB2DVARBPROC           ) SafeCall;
    glVertexAttrib3svARB            = (PFNGLVERTEXATTRIB3SVARBPROC           ) SafeCall;
    glVertexAttrib3fvARB            = (PFNGLVERTEXATTRIB3FVARBPROC           ) SafeCall;
    glVertexAttrib3dvARB            = (PFNGLVERTEXATTRIB3DVARBPROC           ) SafeCall;
    glVertexAttrib4bvARB            = (PFNGLVERTEXATTRIB4BVARBPROC           ) SafeCall;
    glVertexAttrib4svARB            = (PFNGLVERTEXATTRIB4SVARBPROC           ) SafeCall;
    glVertexAttrib4ivARB            = (PFNGLVERTEXATTRIB4IVARBPROC           ) SafeCall;
    glVertexAttrib4ubvARB           = (PFNGLVERTEXATTRIB4UBVARBPROC          ) SafeCall;
    glVertexAttrib4usvARB           = (PFNGLVERTEXATTRIB4USVARBPROC          ) SafeCall;
    glVertexAttrib4uivARB           = (PFNGLVERTEXATTRIB4UIVARBPROC          ) SafeCall;
    glVertexAttrib4fvARB            = (PFNGLVERTEXATTRIB4FVARBPROC           ) SafeCall;
    glVertexAttrib4dvARB            = (PFNGLVERTEXATTRIB4DVARBPROC           ) SafeCall;
    glVertexAttrib4NbvARB           = (PFNGLVERTEXATTRIB4NBVARBPROC          ) SafeCall;
    glVertexAttrib4NsvARB           = (PFNGLVERTEXATTRIB4NSVARBPROC          ) SafeCall;
    glVertexAttrib4NivARB           = (PFNGLVERTEXATTRIB4NIVARBPROC          ) SafeCall;
    glVertexAttrib4NubvARB          = (PFNGLVERTEXATTRIB4NUBVARBPROC         ) SafeCall;
    glVertexAttrib4NusvARB          = (PFNGLVERTEXATTRIB4NUSVARBPROC         ) SafeCall;
    glVertexAttrib4NuivARB          = (PFNGLVERTEXATTRIB4NUIVARBPROC         ) SafeCall;
    glVertexAttribPointerARB        = (PFNGLVERTEXATTRIBPOINTERARBPROC       ) SafeCall;
    glEnableVertexAttribArrayARB    = (PFNGLENABLEVERTEXATTRIBARRAYARBPROC   ) SafeCall;
    glDisableVertexAttribArrayARB   = (PFNGLDISABLEVERTEXATTRIBARRAYARBPROC  ) SafeCall;
    glProgramStringARB              = (PFNGLPROGRAMSTRINGARBPROC             ) SafeCall;
    glBindProgramARB                = (PFNGLBINDPROGRAMARBPROC               ) SafeCall;
    glDeleteProgramsARB             = (PFNGLDELETEPROGRAMSARBPROC            ) SafeCall;
    glGenProgramsARB                = (PFNGLGENPROGRAMSARBPROC               ) SafeCall;
    glProgramEnvParameter4dARB      = (PFNGLPROGRAMENVPARAMETER4DARBPROC     ) SafeCall;
    glProgramEnvParameter4dvARB     = (PFNGLPROGRAMENVPARAMETER4DVARBPROC    ) SafeCall;
    glProgramEnvParameter4fARB      = (PFNGLPROGRAMENVPARAMETER4FARBPROC     ) SafeCall;
    glProgramEnvParameter4fvARB     = (PFNGLPROGRAMENVPARAMETER4FVARBPROC    ) SafeCall;
    glProgramLocalParameter4dARB    = (PFNGLPROGRAMLOCALPARAMETER4DARBPROC   ) SafeCall;
    glProgramLocalParameter4dvARB   = (PFNGLPROGRAMLOCALPARAMETER4DVARBPROC  ) SafeCall;
    glProgramLocalParameter4fARB    = (PFNGLPROGRAMLOCALPARAMETER4FARBPROC   ) SafeCall;
    glProgramLocalParameter4fvARB   = (PFNGLPROGRAMLOCALPARAMETER4FVARBPROC  ) SafeCall;
    glGetProgramEnvParameterdvARB   = (PFNGLGETPROGRAMENVPARAMETERDVARBPROC  ) SafeCall;
    glGetProgramEnvParameterfvARB   = (PFNGLGETPROGRAMENVPARAMETERFVARBPROC  ) SafeCall;
    glGetProgramLocalParameterdvARB = (PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC) SafeCall;
    glGetProgramLocalParameterfvARB = (PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC) SafeCall;
    glGetProgramivARB               = (PFNGLGETPROGRAMIVARBPROC              ) SafeCall;
    glGetProgramStringARB           = (PFNGLGETPROGRAMSTRINGARBPROC          ) SafeCall;
    glGetVertexAttribdvARB          = (PFNGLGETVERTEXATTRIBDVARBPROC         ) SafeCall;
    glGetVertexAttribfvARB          = (PFNGLGETVERTEXATTRIBFVARBPROC         ) SafeCall;
    glGetVertexAttribivARB          = (PFNGLGETVERTEXATTRIBIVARBPROC         ) SafeCall;
    glGetVertexAttribPointervARB    = (PFNGLGETVERTEXATTRIBPOINTERVARBPROC   ) SafeCall;
    glIsProgramARB                  = (PFNGLISPROGRAMARBPROC                 ) SafeCall;
    
    glPointParameterfARB   = (PFNGLPOINTPARAMETERFARBPROC) SafeCall;
    glPointParameterfvARB  = (PFNGLPOINTPARAMETERFVARBPROC) SafeCall;
    
    glBindBufferARB             = (PFNGLBINDBUFFERARBPROC          ) SafeCall;
    glDeleteBuffersARB          = (PFNGLDELETEBUFFERSARBPROC       ) SafeCall;
    glGenBuffersARB             = (PFNGLGENBUFFERSARBPROC          ) SafeCall;
    glIsBufferARB               = (PFNGLISBUFFERARBPROC            ) SafeCall;
    glBufferDataARB             = (PFNGLBUFFERDATAARBPROC          ) SafeCall;
    glBufferSubDataARB          = (PFNGLBUFFERSUBDATAARBPROC       ) SafeCall;
    glGetBufferSubDataARB       = (PFNGLGETBUFFERSUBDATAARBPROC    ) SafeCall;
    glMapBufferARB              = (PFNGLMAPBUFFERARBPROC           ) SafeCall;
    glUnmapBufferARB            = (PFNGLUNMAPBUFFERARBPROC         ) SafeCall;
    glGetBufferParameterivARB   = (PFNGLGETBUFFERPARAMETERIVARBPROC) SafeCall;
    glGetBufferPointervARB      = (PFNGLGETBUFFERPOINTERVARBPROC   ) SafeCall;

    this->szGlExtensions = strdup((char*) glGetString(GL_EXTENSIONS));
    
    bExtFlag.reserve( HighestExtensionIdentifier );
    bExtMask.reserve( HighestExtensionIdentifier );
    
    for (int i=0; i<HighestExtensionIdentifier; ++i) {
        bExtFlag[i] = false;
        bExtMask[i] = false;
    };    
 
    if (this->Is("GL_ARB_multitexture")) bExtFlag[Multitexture] = true;
    if (this->Is("GL_ARB_point_parameters")) bExtFlag[PointParameters] = true;
    if (this->Is("GL_ARB_point_sprite")) bExtFlag[PointSprite] = true;
    if (this->Is("GL_ARB_texture_cube_map")) bExtFlag[TextureCubeMap] = true;
    if (this->Is("GL_ARB_texture_env_add")) bExtFlag[TextureEnvAdd] = true;
    if (this->Is("GL_ARB_texture_env_combine")) bExtFlag[TextureEnvCombine] = true;
    if (this->Is("GL_ARB_texture_env_dot3")) bExtFlag[TextureEnvDot3] = true;
    if (this->Is("GL_ARB_texture_compression")) bExtFlag[TextureCompression] = true;
    if (this->Is("GL_ARB_vertex_program")) bExtFlag[VertexProgram] = true;
    if (this->Is("GL_ARB_vertex_buffer_object")) bExtFlag[VertexBufferObject] = true;

    if (this->Is("GL_SGIS_generate_mipmap")) bExtFlag[TextureGenerateMipmap] = true;

    if (this->Is("GL_EXT_texture_filter_anisotropic")) bExtFlag[TextureAnisotropicFilter] = true;
    if (this->Is("GL_EXT_blend_color")) bExtFlag[BlendColor] = true;
    if (this->Is("GL_EXT_blend_minmax")) bExtFlag[BlendMinMax] = true;
    if (this->Is("GL_EXT_blend_subtract")) bExtFlag[BlendSubstract] = true;
    if (this->Is("GL_EXT_compiled_vertex_array")) bExtFlag[CompiledVertexArray] = true;
    if (this->Is("GL_EXT_draw_range_elements")) bExtFlag[DrawRangeElements] = true;
    if (this->Is("GL_EXT_fog_coord")) bExtFlag[FogCoord] = true;
    if (this->Is("GL_EXT_packed_pixels")) bExtFlag[PackedPixels] = true;
    if (this->Is("GL_EXT_bgra")) bExtFlag[BGRA] = true;
    if (this->Is("GL_EXT_abgr")) bExtFlag[ARGB] = true;
    if (this->Is("GL_EXT_secondary_color")) bExtFlag[SecondaryColor] = true;
    if (this->Is("GL_EXT_separate_specular_color")) bExtFlag[SeparateSpecularColor] = true;

    if (this->Is("GL_NV_blend_square")) bExtFlag[BlendSquare] = true;

    // initialize pointers
    if (this->Is(Multitexture)) {
        glActiveTextureARB    = (PFNGLACTIVETEXTUREARBPROC)    wglGetProcAddress("glActiveTextureARB");
        glClientActiveTextureARB = (PFNGLCLIENTACTIVETEXTUREARBPROC) wglGetProcAddress("glClientActiveTextureARB");
        glMultiTexCoord1dARB  = (PFNGLMULTITEXCOORD1DARBPROC)  wglGetProcAddress("glMultiTexCoord1dARB");
        glMultiTexCoord1dvARB = (PFNGLMULTITEXCOORD1DVARBPROC) wglGetProcAddress("glMultiTexCoord1dvARB");
        glMultiTexCoord1fARB  = (PFNGLMULTITEXCOORD1FARBPROC ) wglGetProcAddress("glMultiTexCoord1fARB");
        glMultiTexCoord1fvARB = (PFNGLMULTITEXCOORD1FVARBPROC) wglGetProcAddress("glMultiTexCoord1fvARB");
        glMultiTexCoord1iARB  = (PFNGLMULTITEXCOORD1IARBPROC ) wglGetProcAddress("glMultiTexCoord1iARB");
        glMultiTexCoord1ivARB = (PFNGLMULTITEXCOORD1IVARBPROC) wglGetProcAddress("glMultiTexCoord1ivARB");
        glMultiTexCoord1sARB  = (PFNGLMULTITEXCOORD1SARBPROC ) wglGetProcAddress("glMultiTexCoord1sARB");
        glMultiTexCoord1svARB = (PFNGLMULTITEXCOORD1SVARBPROC) wglGetProcAddress("glMultiTexCoord1svARB");
        glMultiTexCoord2dARB  = (PFNGLMULTITEXCOORD2DARBPROC ) wglGetProcAddress("glMultiTexCoord2dARB");
        glMultiTexCoord2dvARB = (PFNGLMULTITEXCOORD2DVARBPROC) wglGetProcAddress("glMultiTexCoord2dvARB");
        glMultiTexCoord2fARB  = (PFNGLMULTITEXCOORD2FARBPROC ) wglGetProcAddress("glMultiTexCoord2fARB");
        glMultiTexCoord2fvARB = (PFNGLMULTITEXCOORD2FVARBPROC) wglGetProcAddress("glMultiTexCoord2fvARB");
        glMultiTexCoord2iARB  = (PFNGLMULTITEXCOORD2IARBPROC ) wglGetProcAddress("glMultiTexCoord2iARB");
        glMultiTexCoord2ivARB = (PFNGLMULTITEXCOORD2IVARBPROC) wglGetProcAddress("glMultiTexCoord2ivARB");
        glMultiTexCoord2sARB  = (PFNGLMULTITEXCOORD2SARBPROC ) wglGetProcAddress("glMultiTexCoord2sARB");
        glMultiTexCoord2svARB = (PFNGLMULTITEXCOORD2SVARBPROC) wglGetProcAddress("glMultiTexCoord2svARB");
        glMultiTexCoord3dARB  = (PFNGLMULTITEXCOORD3DARBPROC ) wglGetProcAddress("glMultiTexCoord3dARB");
        glMultiTexCoord3dvARB = (PFNGLMULTITEXCOORD3DVARBPROC) wglGetProcAddress("glMultiTexCoord3dvARB");
        glMultiTexCoord3fARB  = (PFNGLMULTITEXCOORD3FARBPROC ) wglGetProcAddress("glMultiTexCoord3fARB");
        glMultiTexCoord3fvARB = (PFNGLMULTITEXCOORD3FVARBPROC) wglGetProcAddress("glMultiTexCoord3fvARB");
        glMultiTexCoord3iARB  = (PFNGLMULTITEXCOORD3IARBPROC ) wglGetProcAddress("glMultiTexCoord3iARB");
        glMultiTexCoord3ivARB = (PFNGLMULTITEXCOORD3IVARBPROC) wglGetProcAddress("glMultiTexCoord3ivARB");
        glMultiTexCoord3sARB  = (PFNGLMULTITEXCOORD3SARBPROC ) wglGetProcAddress("glMultiTexCoord3sARB");
        glMultiTexCoord3svARB = (PFNGLMULTITEXCOORD3SVARBPROC) wglGetProcAddress("glMultiTexCoord3svARB");
        glMultiTexCoord4dARB  = (PFNGLMULTITEXCOORD4DARBPROC ) wglGetProcAddress("glMultiTexCoord4dARB");
        glMultiTexCoord4dvARB = (PFNGLMULTITEXCOORD4DVARBPROC) wglGetProcAddress("glMultiTexCoord4dvARB");
        glMultiTexCoord4fARB  = (PFNGLMULTITEXCOORD4FARBPROC ) wglGetProcAddress("glMultiTexCoord4fARB");
        glMultiTexCoord4fvARB = (PFNGLMULTITEXCOORD4FVARBPROC) wglGetProcAddress("glMultiTexCoord4fvARB");
        glMultiTexCoord4iARB  = (PFNGLMULTITEXCOORD4IARBPROC ) wglGetProcAddress("glMultiTexCoord4iARB");
        glMultiTexCoord4ivARB = (PFNGLMULTITEXCOORD4IVARBPROC) wglGetProcAddress("glMultiTexCoord4ivARB");
        glMultiTexCoord4sARB  = (PFNGLMULTITEXCOORD4SARBPROC ) wglGetProcAddress("glMultiTexCoord4sARB");
        glMultiTexCoord4svARB = (PFNGLMULTITEXCOORD4SVARBPROC) wglGetProcAddress("glMultiTexCoord4svARB");
    };
    
    if (this->Is(BlendColor)) {
        glBlendColorEXT = (PFNGLBLENDCOLOREXTPROC) wglGetProcAddress("glBlendColorEXT");
    };    

    if (this->Is(BlendMinMax)) {
        glBlendEquationEXT = (PFNGLBLENDEQUATIONEXTPROC) wglGetProcAddress("glBlendEquationEXT");
    };    
    
    if (this->Is(CompiledVertexArray)) {
        glLockArraysEXT   = (PFNGLLOCKARRAYSEXTPROC  ) wglGetProcAddress("glLockArraysEXT");
        glUnlockArraysEXT = (PFNGLUNLOCKARRAYSEXTPROC) wglGetProcAddress("glUnlockArraysEXT");
    };
    
    if (this->Is(DrawRangeElements)) {
        glDrawRangeElementsEXT = (PFNGLDRAWRANGEELEMENTSEXTPROC) wglGetProcAddress("glDrawRangeElementsEXT");
    };
    
    if (this->Is(FogCoord)) {
        glFogCoordfEXT       = (PFNGLFOGCOORDFEXTPROC      ) wglGetProcAddress("glFogCoordfEXT");
        glFogCoordfvEXT      = (PFNGLFOGCOORDFVEXTPROC     ) wglGetProcAddress("glFogCoordfvEXT");
        glFogCoorddEXT       = (PFNGLFOGCOORDDEXTPROC      ) wglGetProcAddress("glFogCoorddEXT");
        glFogCoorddvEXT      = (PFNGLFOGCOORDDVEXTPROC     ) wglGetProcAddress("glFogCoorddvEXT");
        glFogCoordPointerEXT = (PFNGLFOGCOORDPOINTEREXTPROC) wglGetProcAddress("glFogCoordPointerEXT");
    };

    if (this->Is(SecondaryColor)) {
        glSecondaryColor3bEXT      = (PFNGLSECONDARYCOLOR3BEXTPROC     ) wglGetProcAddress("glSecondaryColor3bEXT");
        glSecondaryColor3bvEXT     = (PFNGLSECONDARYCOLOR3BVEXTPROC    ) wglGetProcAddress("glSecondaryColor3bvEXT");
        glSecondaryColor3dEXT      = (PFNGLSECONDARYCOLOR3DEXTPROC     ) wglGetProcAddress("glSecondaryColor3dEXT");
        glSecondaryColor3dvEXT     = (PFNGLSECONDARYCOLOR3DVEXTPROC    ) wglGetProcAddress("glSecondaryColor3dvEXT");
        glSecondaryColor3fEXT      = (PFNGLSECONDARYCOLOR3FEXTPROC     ) wglGetProcAddress("glSecondaryColor3fEXT");
        glSecondaryColor3fvEXT     = (PFNGLSECONDARYCOLOR3FVEXTPROC    ) wglGetProcAddress("glSecondaryColor3fvEXT");
        glSecondaryColor3iEXT      = (PFNGLSECONDARYCOLOR3IEXTPROC     ) wglGetProcAddress("glSecondaryColor3iEXT");
        glSecondaryColor3ivEXT     = (PFNGLSECONDARYCOLOR3IVEXTPROC    ) wglGetProcAddress("glSecondaryColor3ivEXT");
        glSecondaryColor3sEXT      = (PFNGLSECONDARYCOLOR3SEXTPROC     ) wglGetProcAddress("glSecondaryColor3sEXT");
        glSecondaryColor3svEXT     = (PFNGLSECONDARYCOLOR3SVEXTPROC    ) wglGetProcAddress("glSecondaryColor3svEXT");
        glSecondaryColor3ubEXT     = (PFNGLSECONDARYCOLOR3UBEXTPROC    ) wglGetProcAddress("glSecondaryColor3ubEXT");
        glSecondaryColor3ubvEXT    = (PFNGLSECONDARYCOLOR3UBVEXTPROC   ) wglGetProcAddress("glSecondaryColor3ubvEXT");
        glSecondaryColor3uiEXT     = (PFNGLSECONDARYCOLOR3UIEXTPROC    ) wglGetProcAddress("glSecondaryColor3uiEXT");
        glSecondaryColor3uivEXT    = (PFNGLSECONDARYCOLOR3UIVEXTPROC   ) wglGetProcAddress("glSecondaryColor3uivEXT");
        glSecondaryColor3usEXT     = (PFNGLSECONDARYCOLOR3USEXTPROC    ) wglGetProcAddress("glSecondaryColor3usEXT");
        glSecondaryColor3usvEXT    = (PFNGLSECONDARYCOLOR3USVEXTPROC   ) wglGetProcAddress("glSecondaryColor3usvEXT");
        glSecondaryColorPointerEXT = (PFNGLSECONDARYCOLORPOINTEREXTPROC) wglGetProcAddress("glSecondaryColorPointerEXT");
    };

    if (this->Is(TextureCompression)) {
        glCompressedTexImage3DARB     = (PFNGLCOMPRESSEDTEXIMAGE3DARBPROC   ) wglGetProcAddress("glCompressedTexImage3DARB");
        glCompressedTexImage2DARB     = (PFNGLCOMPRESSEDTEXIMAGE2DARBPROC   ) wglGetProcAddress("glCompressedTexImage2DARB");
        glCompressedTexImage1DARB     = (PFNGLCOMPRESSEDTEXIMAGE1DARBPROC   ) wglGetProcAddress("glCompressedTexImage1DARB");
        glCompressedTexSubImage3DARB  = (PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC) wglGetProcAddress("glCompressedTexSubImage3DARB");
        glCompressedTexSubImage2DARB  = (PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC) wglGetProcAddress("glCompressedTexSubImage2DARB");
        glCompressedTexSubImage1DARB  = (PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC) wglGetProcAddress("glCompressedTexSubImage1DARB");
        glGetCompressedTexImageARB    = (PFNGLGETCOMPRESSEDTEXIMAGEARBPROC  ) wglGetProcAddress("glGetCompressedTexImageARB");
    };    

    if (this->Is(VertexProgram)) {
        glVertexAttrib1sARB             = (PFNGLVERTEXATTRIB1SARBPROC            ) wglGetProcAddress("glVertexAttrib1sARB");
        glVertexAttrib1fARB             = (PFNGLVERTEXATTRIB1FARBPROC            ) wglGetProcAddress("glVertexAttrib1fARB");
        glVertexAttrib1dARB             = (PFNGLVERTEXATTRIB1DARBPROC            ) wglGetProcAddress("glVertexAttrib1dARB");
        glVertexAttrib2sARB             = (PFNGLVERTEXATTRIB2SARBPROC            ) wglGetProcAddress("glVertexAttrib2sARB");
        glVertexAttrib2fARB             = (PFNGLVERTEXATTRIB2FARBPROC            ) wglGetProcAddress("glVertexAttrib2fARB");
        glVertexAttrib2dARB             = (PFNGLVERTEXATTRIB2DARBPROC            ) wglGetProcAddress("glVertexAttrib2dARB");
        glVertexAttrib3sARB             = (PFNGLVERTEXATTRIB3SARBPROC            ) wglGetProcAddress("glVertexAttrib3sARB");
        glVertexAttrib3fARB             = (PFNGLVERTEXATTRIB3FARBPROC            ) wglGetProcAddress("glVertexAttrib3fARB");
        glVertexAttrib3dARB             = (PFNGLVERTEXATTRIB3DARBPROC            ) wglGetProcAddress("glVertexAttrib3dARB");
        glVertexAttrib4sARB             = (PFNGLVERTEXATTRIB4SARBPROC            ) wglGetProcAddress("glVertexAttrib4sARB");
        glVertexAttrib4fARB             = (PFNGLVERTEXATTRIB4FARBPROC            ) wglGetProcAddress("glVertexAttrib4fARB");
        glVertexAttrib4dARB             = (PFNGLVERTEXATTRIB4DARBPROC            ) wglGetProcAddress("glVertexAttrib4dARB");
        glVertexAttrib4NubARB           = (PFNGLVERTEXATTRIB4NUBARBPROC          ) wglGetProcAddress("glVertexAttrib4NubARB");
        glVertexAttrib1svARB            = (PFNGLVERTEXATTRIB1SVARBPROC           ) wglGetProcAddress("glVertexAttrib1svARB");
        glVertexAttrib1fvARB            = (PFNGLVERTEXATTRIB1FVARBPROC           ) wglGetProcAddress("glVertexAttrib1fvARB");
        glVertexAttrib1dvARB            = (PFNGLVERTEXATTRIB1DVARBPROC           ) wglGetProcAddress("glVertexAttrib1dvARB");
        glVertexAttrib2svARB            = (PFNGLVERTEXATTRIB2SVARBPROC           ) wglGetProcAddress("glVertexAttrib2svARB");
        glVertexAttrib2fvARB            = (PFNGLVERTEXATTRIB2FVARBPROC           ) wglGetProcAddress("glVertexAttrib2fvARB");
        glVertexAttrib2dvARB            = (PFNGLVERTEXATTRIB2DVARBPROC           ) wglGetProcAddress("glVertexAttrib2dvARB");
        glVertexAttrib3svARB            = (PFNGLVERTEXATTRIB3SVARBPROC           ) wglGetProcAddress("glVertexAttrib3svARB");
        glVertexAttrib3fvARB            = (PFNGLVERTEXATTRIB3FVARBPROC           ) wglGetProcAddress("glVertexAttrib3fvARB");
        glVertexAttrib3dvARB            = (PFNGLVERTEXATTRIB3DVARBPROC           ) wglGetProcAddress("glVertexAttrib3dvARB");
        glVertexAttrib4bvARB            = (PFNGLVERTEXATTRIB4BVARBPROC           ) wglGetProcAddress("glVertexAttrib4bvARB");
        glVertexAttrib4svARB            = (PFNGLVERTEXATTRIB4SVARBPROC           ) wglGetProcAddress("glVertexAttrib4svARB");
        glVertexAttrib4ivARB            = (PFNGLVERTEXATTRIB4IVARBPROC           ) wglGetProcAddress("glVertexAttrib4ivARB");
        glVertexAttrib4ubvARB           = (PFNGLVERTEXATTRIB4UBVARBPROC          ) wglGetProcAddress("glVertexAttrib4ubvARB");
        glVertexAttrib4usvARB           = (PFNGLVERTEXATTRIB4USVARBPROC          ) wglGetProcAddress("glVertexAttrib4usvARB");
        glVertexAttrib4uivARB           = (PFNGLVERTEXATTRIB4UIVARBPROC          ) wglGetProcAddress("glVertexAttrib4uivARB");
        glVertexAttrib4fvARB            = (PFNGLVERTEXATTRIB4FVARBPROC           ) wglGetProcAddress("glVertexAttrib4fvARB");
        glVertexAttrib4dvARB            = (PFNGLVERTEXATTRIB4DVARBPROC           ) wglGetProcAddress("glVertexAttrib4dvARB");
        glVertexAttrib4NbvARB           = (PFNGLVERTEXATTRIB4NBVARBPROC          ) wglGetProcAddress("glVertexAttrib4NbvARB");
        glVertexAttrib4NsvARB           = (PFNGLVERTEXATTRIB4NSVARBPROC          ) wglGetProcAddress("glVertexAttrib4NsvARB");
        glVertexAttrib4NivARB           = (PFNGLVERTEXATTRIB4NIVARBPROC          ) wglGetProcAddress("glVertexAttrib4NivARB");
        glVertexAttrib4NubvARB          = (PFNGLVERTEXATTRIB4NUBVARBPROC         ) wglGetProcAddress("glVertexAttrib4NubvARB");
        glVertexAttrib4NusvARB          = (PFNGLVERTEXATTRIB4NUSVARBPROC         ) wglGetProcAddress("glVertexAttrib4NusvARB");
        glVertexAttrib4NuivARB          = (PFNGLVERTEXATTRIB4NUIVARBPROC         ) wglGetProcAddress("glVertexAttrib4NuivARB");
        glVertexAttribPointerARB        = (PFNGLVERTEXATTRIBPOINTERARBPROC       ) wglGetProcAddress("glVertexAttribPointerARB");
        glEnableVertexAttribArrayARB    = (PFNGLENABLEVERTEXATTRIBARRAYARBPROC   ) wglGetProcAddress("glEnableVertexAttribArrayARB");
        glDisableVertexAttribArrayARB   = (PFNGLDISABLEVERTEXATTRIBARRAYARBPROC  ) wglGetProcAddress("glDisableVertexAttribArrayARB");
        glProgramStringARB              = (PFNGLPROGRAMSTRINGARBPROC             ) wglGetProcAddress("glProgramStringARB");
        glBindProgramARB                = (PFNGLBINDPROGRAMARBPROC               ) wglGetProcAddress("glBindProgramARB");
        glDeleteProgramsARB             = (PFNGLDELETEPROGRAMSARBPROC            ) wglGetProcAddress("glDeleteProgramsARB");
        glGenProgramsARB                = (PFNGLGENPROGRAMSARBPROC               ) wglGetProcAddress("glGenProgramsARB");
        glProgramEnvParameter4dARB      = (PFNGLPROGRAMENVPARAMETER4DARBPROC     ) wglGetProcAddress("glProgramEnvParameter4dARB");
        glProgramEnvParameter4dvARB     = (PFNGLPROGRAMENVPARAMETER4DVARBPROC    ) wglGetProcAddress("glProgramEnvParameter4dvARB");
        glProgramEnvParameter4fARB      = (PFNGLPROGRAMENVPARAMETER4FARBPROC     ) wglGetProcAddress("glProgramEnvParameter4fARB");
        glProgramEnvParameter4fvARB     = (PFNGLPROGRAMENVPARAMETER4FVARBPROC    ) wglGetProcAddress("glProgramEnvParameter4fvARB");
        glProgramLocalParameter4dARB    = (PFNGLPROGRAMLOCALPARAMETER4DARBPROC   ) wglGetProcAddress("glProgramLocalParameter4dARB");
        glProgramLocalParameter4dvARB   = (PFNGLPROGRAMLOCALPARAMETER4DVARBPROC  ) wglGetProcAddress("glProgramLocalParameter4dvARB");
        glProgramLocalParameter4fARB    = (PFNGLPROGRAMLOCALPARAMETER4FARBPROC   ) wglGetProcAddress("glProgramLocalParameter4fARB");
        glProgramLocalParameter4fvARB   = (PFNGLPROGRAMLOCALPARAMETER4FVARBPROC  ) wglGetProcAddress("glProgramLocalParameter4fvARB");
        glGetProgramEnvParameterdvARB   = (PFNGLGETPROGRAMENVPARAMETERDVARBPROC  ) wglGetProcAddress("glGetProgramEnvParameterdvARB");
        glGetProgramEnvParameterfvARB   = (PFNGLGETPROGRAMENVPARAMETERFVARBPROC  ) wglGetProcAddress("glGetProgramEnvParameterfvARB");
        glGetProgramLocalParameterdvARB = (PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC) wglGetProcAddress("glGetProgramLocalParameterdvARB");
        glGetProgramLocalParameterfvARB = (PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC) wglGetProcAddress("glGetProgramLocalParameterfvARB");
        glGetProgramivARB               = (PFNGLGETPROGRAMIVARBPROC              ) wglGetProcAddress("glGetProgramivARB");
        glGetProgramStringARB           = (PFNGLGETPROGRAMSTRINGARBPROC          ) wglGetProcAddress("glGetProgramStringARB");
        glGetVertexAttribdvARB          = (PFNGLGETVERTEXATTRIBDVARBPROC         ) wglGetProcAddress("glGetVertexAttribdvARB");
        glGetVertexAttribfvARB          = (PFNGLGETVERTEXATTRIBFVARBPROC         ) wglGetProcAddress("glGetVertexAttribfvARB");
        glGetVertexAttribivARB          = (PFNGLGETVERTEXATTRIBIVARBPROC         ) wglGetProcAddress("glGetVertexAttribivARB");
        glGetVertexAttribPointervARB    = (PFNGLGETVERTEXATTRIBPOINTERVARBPROC   ) wglGetProcAddress("glGetVertexAttribPointervARB");
        glIsProgramARB                  = (PFNGLISPROGRAMARBPROC                 ) wglGetProcAddress("glIsProgramARB");
    };
    
    if (this->Is(PointParameters)) {
        glPointParameterfARB   = (PFNGLPOINTPARAMETERFARBPROC)  wglGetProcAddress("glPointParameterfARB");
        glPointParameterfvARB  = (PFNGLPOINTPARAMETERFVARBPROC) wglGetProcAddress("glPointParameterfvARB");
    };

    if (this->Is(VertexBufferObject)) {
        glBindBufferARB             = (PFNGLBINDBUFFERARBPROC          ) wglGetProcAddress("glBindBufferARB");
        glDeleteBuffersARB          = (PFNGLDELETEBUFFERSARBPROC       ) wglGetProcAddress("glDeleteBuffersARB");
        glGenBuffersARB             = (PFNGLGENBUFFERSARBPROC          ) wglGetProcAddress("glGenBuffersARB");
        glIsBufferARB               = (PFNGLISBUFFERARBPROC            ) wglGetProcAddress("glIsBufferARB");
        glBufferDataARB             = (PFNGLBUFFERDATAARBPROC          ) wglGetProcAddress("glBufferDataARB");
        glBufferSubDataARB          = (PFNGLBUFFERSUBDATAARBPROC       ) wglGetProcAddress("glBufferSubDataARB");
        glGetBufferSubDataARB       = (PFNGLGETBUFFERSUBDATAARBPROC    ) wglGetProcAddress("glGetBufferSubDataARB");
        glMapBufferARB              = (PFNGLMAPBUFFERARBPROC           ) wglGetProcAddress("glMapBufferARB");
        glUnmapBufferARB            = (PFNGLUNMAPBUFFERARBPROC         ) wglGetProcAddress("glUnmapBufferARB");
        glGetBufferParameterivARB   = (PFNGLGETBUFFERPARAMETERIVARBPROC) wglGetProcAddress("glGetBufferParameterivARB");
        glGetBufferPointervARB      = (PFNGLGETBUFFERPOINTERVARBPROC   ) wglGetProcAddress("glGetBufferPointervARB");
    };    
        
    return;
};      
        
Aegis::G1::Extension::~Extension() {
    return;
};      
        
__fastcall bool Aegis::G1::Extension::Is(const int id) const {
    if (id < 0 || id >= HighestExtensionIdentifier)
        return false;
        
    if (bExtMask[id])
        return false; // extension is masked out
    else
        return bExtFlag[id];
};    

__fastcall bool Aegis::G1::Extension::Is(const char *name) const {
	int pos = 0;
	int maxpos = strlen(name)-1;
	int len = strlen(this->szGlExtensions);	
	char *other;
	for (int i = 0; i < len; i++) {
		if ((i == 0) || ((i > 1) && this->szGlExtensions[i-1] == ' ')) {
			other = &this->szGlExtensions[i];
			pos = 0;
			while (this->szGlExtensions[i] != ' ') {
				if (this->szGlExtensions[i] == name[pos]) ++pos;
				if ((pos > maxpos) && this->szGlExtensions[i+1] == ' ') return true;
				++i;
			}
		}
	}
	return false;
	
//	return !!strstr( this->szGlExtensions, name ); 
};

__fastcall bool Aegis::G1::Extension::Mask(const int id, bool disable) {
    if (id < 0 || id >= HighestExtensionIdentifier)
        return false;

    bool old = bExtMask[id];
    bExtMask[id] = disable;
    
    return old;
};    

// Safe functions implementation
void SafeCall(...) {
    MessageBox(NULL,
               "Major application error: Unavailable OpenGL extension function called directly.\n"
               "This may mean that your OpenGL extensions does not meet this application's requirements.\n\n"
               "Unable to continue...","Aegis Engine",MB_ICONSTOP);
    exit(1);
};


