/*
  Name: aG1_FrustumCull.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G1 - Frustum Culling
*/

#ifndef _AG1_FRUSTUMCULL_HPP
#define _AG1_FRUSTUMCULL_HPP

#include <windows.h>
#include <gl/gl.h>

#include "../../M/M2/aM2_Vertex.hpp"

namespace Aegis {
    namespace G1 {

        class Frustum {
            private:
                void NormalizePlane(int side);
                float m_Frustum[6][4];
                
            public:
                __fastcall Frustum();
                __fastcall ~Frustum();

                __fastcall void ReCalculateFrustum();
                __fastcall bool PointInFrustum(const Aegis::M2::Vertex & v);
                __fastcall bool SphereInFrustum(const Aegis::M2::Vertex &,
                                                float radius);
                __fastcall bool CubeInFrustum(const Aegis::M2::Vertex &,
                                              float size );
                __fastcall bool FaceInFrustum(const Aegis::M2::Vertex & v1,
                                              const Aegis::M2::Vertex & v2,
                                              const Aegis::M2::Vertex & v3);
                __fastcall bool RectInFrustum(const Aegis::M2::Vertex v[4]);
        };    
        
    };
};    

#endif

