/*
  Name: aG1_RawBlock.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G1 - User block of OpenGL
*/

#include "aG1_RawBlock.hpp"
#include "aG1_EffectiveGL.hpp"

__fastcall Aegis::G1::RawBlock::RawBlock( const Aegis::G1::Renderer & ren )
           : renderer(ren) {
    return;
};

__fastcall int Aegis::G1::RawBlock::Call( int param ) {
    int ret = 0;
    
    // store current state
    renderer.Textures->Push();
    renderer.Materials->Push();
    renderer.Fog->Push();
    renderer.Blend->Push();
    
    Aegis::G1::PushMatrixObjectf *PMO = new Aegis::G1::PushMatrixObjectf;
    glPushAttrib( GL_ALL_ATTRIB_BITS );
    glPushClientAttrib( GL_CLIENT_ALL_ATTRIB_BITS );

    // call the user defined function
    ret = this->Code( param );
    
    // restore current state
    glPopClientAttrib();
    glPopAttrib();
    delete PMO;
    
    renderer.Blend->Pop();
    renderer.Fog->Pop();
    renderer.Materials->Pop();
    renderer.Textures->Pop();
    
    return ret;
};    

