/*
  Name: aG2_CubeMap.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G2 - CubeMap Class
*/

#ifndef _AG2_CUBEMAP_HPP
#define _AG2_CUBEMAP_HPP

#include <gl/gl.h>

namespace Aegis {
    namespace G2 {
        
        class CubeMap;
        
    };
};

#include "aG2_Texture.hpp"

namespace Aegis {
    namespace G2 {
        
        class CubeMap : public Texture {
            private:
                // texture is inherited
                
            public:
                inline CubeMap() { };
                inline CubeMap( const Aegis::G1::Renderer & rndr,
                                const Aegis::F::Bitmap b[6] ) {
                    this->Build( rndr, b );
                };

                // create cubemap from 6 bitmaps
                __fastcall int Build( const Aegis::G1::Renderer &,
                                      const Aegis::F::Bitmap b[6] ,
                                      bool mipmap = true, int filter = 1,
                                      float aniso = 1.0f );
                                      
                // normalization cube map
                int BuildNormalizationMap(const Aegis::G1::Renderer &);

                // retrieve requested bitmap
                __fastcall Aegis::F::Bitmap *
                MakeBitmap( const Aegis::G1::Renderer & rn,
                            int side, int mipmap = 0 ) const;

                // parameters
                __fastcall void SetParams( const Aegis::G1::Renderer &,
                                           bool mipmap = true,
                                           int filter = 1, 
                                           float anisotropic = 1.0f // none
                                           );
                __fastcall void SetPriority( const Aegis::G1::Renderer &,
                                             float priority );                
        };
        
    };
};

#endif
  
