/*
  Name: aG2_Face.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G2 - Triangle (Face) Class
*/

#ifndef _AG2_FACE_HPP
#define _AG2_FACE_HPP

#include "../../Attribs.hpp"
#include "../../M/aM.hpp"
#include "../G1/aG1_Renderer.hpp"
#include "aG2_TexUnit.hpp"
#include <gl/gl.h>

namespace Aegis {
    namespace G2 {
        
        class __aligned Face {
            public:
                Aegis::M2::Vertex       vertex[3];
                Aegis::M2::Normal       normal[3];
                Aegis::M2::Color        color [3];
                Aegis::M2::TexCoord     coord [3];

                Aegis::G2::TexUnit      texunit;

                float fog[3];
                
                inline Face() {
                    fog[0] = fog[1] = fog[2] = 0.0f;
                    return;
                };//*/
                inline ~Face() { };
                
                virtual __fastcall void Draw( const Aegis::G1::Renderer& );
        };
        
    };    
};    


#endif

