/*
  Name: aG2_Font.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G2 - Font Class
*/

#ifndef _AG2_FONT_HPP
#define _AG2_FONT_HPP

#include "../../Attribs.hpp"
#include "../../F/aF_Bitmap.hpp"
#include "../G1/aG1_Renderer.hpp"
#include "aG2_Texture.hpp"

namespace Aegis {
    namespace G2 {
        
        class __aligned Font {
            private:
                const Aegis::G1::Renderer renderer;
                
                Aegis::G2::Texture tex;

                float offsetx[256];
                float offsety[256];
                float width[256];
                float baseline;
                
                int mode; // 0 - baseline, 1 - 
                
            public:
                Font( const Aegis::G1::Renderer &ren );
                Font( const Aegis::G1::Renderer &ren,
                      const Aegis::F::Bitmap & bm, bool fixed );
                ~Font();
                
                // building font from bitmaps
                __fastcall void Build( const Aegis::F::Bitmap & bm,
                                       bool fixedwidth );
                __fastcall void Assign( const Aegis::F::Bitmap & bm,
                                        bool fixedwidth ); // TODO;

                // output mode functions
                __fastcall void SetMode(int mode);

                // output functions                
                __cdecl    int Printf( float x, float y, float size,
                                       const char *sz, ... );

                __fastcall float getwidth(const unsigned char c);
                __fastcall float getwidth(const char *sz);

                __fastcall int puts( float x, float y, float size,
                                     const char * sz );
                __fastcall int putc( float x, float y, float size,
                                     const unsigned char c );
                
        };
        
    };
};

#endif
          
