/*
  Name: aG2_Material.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G2 - Material Class
*/

#include "aG2_Material.hpp"

namespace Aegis {
    namespace G2 {
        
        static Material Material_Cache;
        
    };
};

__fastcall void Aegis::G2::Material::Correct() {
    
    this->ambient.Correct();
    this->diffuse.Correct();
    this->specular.Correct();
    this->emission.Correct();
    
    this->back_ambient.Correct();
    this->back_diffuse.Correct();
    this->back_specular.Correct();
    this->back_emission.Correct();
    
    if (this->shininess < 0.0f)   this->shininess = 0.0f;
    if (this->shininess > 128.0f) this->shininess = 128.0f;

    if (this->back_shininess < 0.0f)   this->back_shininess = 0.0f;
    if (this->back_shininess > 128.0f) this->back_shininess = 128.0f;
    
    return;
};

__fastcall void Aegis::G2::Material::Apply( const Aegis::G1::Renderer& ren ) {
    if (this->double_sided) {
        ren.Materials->Apply( this->ambient, this->diffuse,
                              this->specular, this->emission,
                              this->shininess,
                              this->back_ambient, this->back_diffuse,
                              this->back_specular, this->back_emission,
                              this->back_shininess );
    } else {
        ren.Materials->Apply( this->ambient, this->diffuse,
                              this->specular,this->emission,
                              this->shininess );
    };

    return;
};    



