/*
  Name: aG2_MultiFace.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G2 - Multitextured Face Class
*/

#ifndef _AG2_MULTIFACE_HPP
#define _AG2_MULTIFACE_HPP

#include <gl/gl.h>

#include "../../Attribs.hpp"
#include "../../M/aM.hpp"
#include "../G1/aG1_Renderer.hpp"
#include "aG2_Face.hpp"
#include "aG2_TexUnit.hpp"

#define AEGIS_G2_MULTIFACE_NTEX 16 // maximum of textures

namespace Aegis {
    namespace G2 {

        class __aligned MultiFace : virtual public Face {
            public:
                // override texture mapping
                Aegis::M2::TexCoord     coord [ AEGIS_G2_MULTIFACE_NTEX ][3];
                Aegis::G2::TexUnit      texunit[ AEGIS_G2_MULTIFACE_NTEX ];
                
                inline MultiFace() { };
                inline ~MultiFace() { };

                __fastcall void Draw( const Aegis::G1::Renderer&,
                                      bool ignorecombiners = false );
                // Slow! Faces and MultiFaces should be packed to Elements
        };
        
    };    
};    


#endif

