/*
  Name: aG2_Sprite.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G2 - Sprite (Billboard) Class
*/

#ifndef _AG2_SPRITE_HPP
#define _AG2_SPRITE_HPP

#include "../../Attribs.hpp"
#include "../../M/aM.hpp"
#include "../G1/aG1_Renderer.hpp"
#include "aG2_Texture.hpp"

namespace Aegis {
    namespace G2 {
        
        class __aligned Sprite {
            public:
                Aegis::M2::Vertex  position;
                Aegis::M2::Color   color;
                Aegis::G2::Texture *texture;
                
                float size;
                float fog;
            public:
                Sprite() : size(1.0f), fog(0.0f) { };
                ~Sprite() { };
                
                inline void Draw( const Aegis::G1::Renderer * ren ) const {
                    if (ren) this->Draw( *ren );
                    return;
                };    
                __fastcall void Draw( const Aegis::G1::Renderer& ) const; // slow!
        };
        
    };    
};    


#endif

