/*
  Name: aG2_TexCombiner.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G2 - TexCombiner Class
*/

#include "aG2_TexCombiner.hpp"

__fastcall void Aegis::G2::TexCombiner::Apply() {
    glTexEnvi( GL_TEXTURE_ENV, GL_COMBINE_RGB_ARB,    this->mode[ 0] );
    glTexEnvi( GL_TEXTURE_ENV, GL_COMBINE_ALPHA_ARB,  this->mode[ 1] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE0_RGB_ARB,    this->mode[ 2] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE1_RGB_ARB,    this->mode[ 3] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE2_RGB_ARB,    this->mode[ 4] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE0_ALPHA_ARB,  this->mode[ 5] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE1_ALPHA_ARB,  this->mode[ 6] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE2_ALPHA_ARB,  this->mode[ 7] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND0_RGB_ARB,   this->mode[ 8] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND1_RGB_ARB,   this->mode[ 9] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND2_RGB_ARB,   this->mode[10] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND0_ALPHA_ARB, this->mode[11] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND1_ALPHA_ARB, this->mode[12] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND2_ALPHA_ARB, this->mode[13] );
    glTexEnvi( GL_TEXTURE_ENV, GL_RGB_SCALE_ARB,      this->mode[14] );
    glTexEnvi( GL_TEXTURE_ENV, GL_ALPHA_SCALE ,       this->mode[15] );
    
    return;
};

__fastcall void Aegis::G2::TexCombiner::Apply( const Aegis::G1::Renderer& ren ) {
    if (!ren.Ext->Is(Aegis::G1::TextureEnvCombine)) return;
    
    glTexEnvi( GL_TEXTURE_ENV, GL_COMBINE_RGB_ARB,    this->mode[ 0] );
    glTexEnvi( GL_TEXTURE_ENV, GL_COMBINE_ALPHA_ARB,  this->mode[ 1] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE0_RGB_ARB,    this->mode[ 2] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE1_RGB_ARB,    this->mode[ 3] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE2_RGB_ARB,    this->mode[ 4] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE0_ALPHA_ARB,  this->mode[ 5] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE1_ALPHA_ARB,  this->mode[ 6] );
    glTexEnvi( GL_TEXTURE_ENV, GL_SOURCE2_ALPHA_ARB,  this->mode[ 7] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND0_RGB_ARB,   this->mode[ 8] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND1_RGB_ARB,   this->mode[ 9] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND2_RGB_ARB,   this->mode[10] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND0_ALPHA_ARB, this->mode[11] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND1_ALPHA_ARB, this->mode[12] );
    glTexEnvi( GL_TEXTURE_ENV, GL_OPERAND2_ALPHA_ARB, this->mode[13] );
    glTexEnvi( GL_TEXTURE_ENV, GL_RGB_SCALE_ARB,      this->mode[14] );
    glTexEnvi( GL_TEXTURE_ENV, GL_ALPHA_SCALE ,       this->mode[15] );
    
    return;
};

__fastcall void Aegis::G2::TexCombiner::Correct() {
    // TODO: check for valid GL_ values
    
    // check for defaultness
    TexCombiner tc;
    if (*this == tc) this->non_default = false;
                else this->non_default = true;
                
    return;
};    



