/*
  Name: aG.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem
*/

#ifndef _AG_HPP
#define _AG_HPP

namespace Aegis {
    namespace G1 {};
    namespace G2 {};
    namespace G3 {};
    namespace G4 {};
};    

#ifdef USING_AEGIS
using namespace Aegis::G1;
using namespace Aegis::G2;
#endif

// G1
#include "G1/aG1_Renderer.hpp"
//#include "G1/aG1_Frame.hpp"
#include "G1/aG1_EffectiveGL.hpp"
#include "G1/aG1_Extension.hpp"
#include "G1/aG1_FrameControl.hpp"
#include "G1/aG1_TextureControl.hpp"
#include "G1/aG1_MaterialControl.hpp"
#include "G1/aG1_FogControl.hpp"
#include "G1/aG1_BlendControl.hpp"
#include "G1/aG1_FrustumCull.hpp"

// G2
#include "G2/aG2_Face.hpp"
#include "G2/aG2_MultiFace.hpp"
#include "G2/aG2_Sprite.hpp"
#include "G2/aG2_Element.hpp"
#include "G2/aG2_Material.hpp"
#include "G2/aG2_Texture.hpp"
#include "G2/aG2_CubeMap.hpp"
#include "G2/aG2_TexUnit.hpp"
#include "G2/aG2_TexCombiner.hpp"
#include "G2/aG2_Font.hpp"

// G3

// G4

#endif

