/*
  Name: aM1_CommonMath.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - M (Math) Subsystem - M1 - Common math
*/

#ifndef _AM1_COMMONMATH_HPP
#define _AM1_COMMONMATH_HPP

#include "../../Attribs.hpp"

namespace Aegis {
    namespace M1 {
        
        extern const float PI;// = 3.1415926535897932384626433832795f;
        extern const float PI_180;// = 0.0174532925199432957692369076848861f;
        extern const float PI_4; // = 1,5707963267948966192313216916398f;
        
        inline float DegToRad( const float deg ) { return deg * PI_180; };
        inline float RadToDeg( const float rad ) { return rad * 180.0f / PI; };
        
        __fastcall float Interpolate( float a, float b, float w ) __const_attr;
        
    };
};

#endif        

