/*
  Name: aM1_Random.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - M (Math) Subsystem - M1 - The Best Randomizer
*/

#ifndef _AM1_RANDOM_HPP
#define _AM1_RANDOM_HPP

#include <stdio.h>
#include <typeinfo>

namespace Aegis {
    namespace M1 {

        class Random {
            private:
                float u[98], c, cd, cm;
                int i97, j97;
                
            public:
                __fastcall Random(int seed1 = 1802, int seed2 = 9373);
                __fastcall void Randomize(int seed);
                
                __fastcall operator float();
                
                // template for returning all the types with limits
                template <class T> T operator()( T limit ) {
                    return (T)((float)limit * (float)(*this));
                };

                // specialize template for float and no type
                inline float operator()( float _l ) { return _l*float(*this); };
                inline float operator()() { return float(*this); };

        };
        
    };
};

extern Aegis::M1::Random random; // global random generator

#endif


