/*
  Name: aM.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - M (Math) Subsystem
*/

#ifndef _AM_HPP
#define _AM_HPP

namespace Aegis {
    namespace M1 { };
    namespace M2 { };
    namespace M3 { };
};    

#ifdef USING_AEGIS
using namespace Aegis::M1;
using namespace Aegis::M2;
using namespace Aegis::M3;
#endif


// M1 - fast, low level, hardware dependent functions
#include "M1/aM1_CommonMath.hpp"
#include "M1/aM1_FastMath.hpp"
#include "M1/aM1_Random.hpp"

// M2 - high level mathematical objects (must be -fast-math compatible)
#include "M2/aM2_RGBA.hpp"
#include "M2/aM2_Vertex.hpp"
#include "M2/aM2_Normal.hpp"
#include "M2/aM2_Color.hpp"
#include "M2/aM2_TexCoord.hpp"
#include "M2/aM2_Sense.hpp"

// M3 - algortihms
#include "M3/aM3_isort.hpp"

#endif

