/*
  Name: aP1_Collision.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - P (Physics) Subsystem - P1 - Face collisions
*/

#ifndef _AP1_COLLISION_HPP
#define _AP1_COLLISION_HPP

#include "../../M/M1/aM1_CommonMath.hpp"
#include "../../M/M1/aM1_FastMath.hpp"
#include "../../M/M2/aM2_Vertex.hpp"
#include "../../G/G2/aG2_Face.hpp"

namespace Aegis {
    namespace P1 {

        // Base object collision functions belongs here
        // NOTE: Try to have functions to have larger parameter first.

        // does point lies near (+- 0.01) to polygon
        __fastcall bool IsInCollision( const Aegis::G2::Face & f,
                                       const Aegis::M2::Vertex & v );
        // does line intersects the polygon
        __fastcall bool IsInCollision( const Aegis::G2::Face & f,
                                       const Aegis::M2::Vertex & v1,
                                       const Aegis::M2::Vertex & v2 );

        // does two faces intersect
        __fastcall bool IsInCollision( const Aegis::G2::Face & f1,
                                       const Aegis::G2::Face & f2 );

    };
};

#endif

