/*
  Name: aW_Console.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - W (Window) Subsystem - Console Class
*/

#ifndef _AW_CONSOLE_HPP
#define _AW_CONSOLE_HPP

#include <windows.h>

namespace Aegis {
    namespace W {
        class Console {
            private:
                HWND hwnd;
                HFONT hFont;
                
                static LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
                CRITICAL_SECTION cs;

            protected:
                char data[25][81];
                int  cx; // cy is always 24
                bool cb;
                int  cr;
                
                bool hold;

            public:
                Console( HWND hParent = HWND_DESKTOP, char *szTitle = NULL );
                ~Console();
                
                void Show();
                void Hide();
                inline bool IsVisible() { return IsWindowVisible(this->hwnd); };
                
                operator HWND() const { return this->hwnd; };
                
                // output mode
                inline void HoldAutoRepaint() { this->hold = true; };
                inline void AllowAutoRepaint() {
                    this->hold = false;
                    InvalidateRect( this->hwnd, NULL, FALSE );
                };
                
                // output
                __fastcall void clear();
                __fastcall void back(); // moves to begin of the line
                __fastcall void clearline();
                __fastcall void putc (char, bool seq = false);
                __cdecl int printf (const char*, ...);
                
                // input
                __fastcall char *getsz( int maxlen );
                
        };
    };
};        

#endif

