/*
  Name: aW_Resolution.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - W (Window) Subsystem - Resolution Class
*/


#ifndef _AW_RESOLUTION_HPP
#define _AW_RESOLUTION_HPP

namespace Aegis {
    namespace W {
        class Resolution { // Default Display resolution settings
            private:
                void Init();
                bool changed;
                
/*                struct _ResItem {
                    int x, y;
                    struct _ResItemBpp {
                        int bpp;
                        int *freq;
                    } *bpp;    
                } *res;    //*/
            public:
                Resolution();
                Resolution( int x, int y, int bpp = 0, int freq = 0 );
                ~Resolution();
                
                bool Set( int x, int y, int bpp = 0, int freq = 0 ); // true if successfull
                bool Test( int x, int y, int bpp = 0, int freq = 0 ); // true if can be set

                // Fills refered parameters by index with supported settings.
                // Returns FALSE if successfull.
                bool Enum( int index, int &x, int &y, int &bpp, int &freq );
//                bool Enum( int index, int &x, int &y );
//                bool Enum( int index, int x, int y, int &bpp );
//                bool Enum( int index, int x, int y, int bpp, int &freq );

                bool Restore(); // true if successfull
        };    
    };
};

#endif

