
/*
  Name: aX_Mode.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - X (eXecution) Subsystem - Mode class
*/

#ifndef _AX_MODE_HPP
#define _AX_MODE_HPP

namespace Aegis {
    namespace X {
        class Mode;
    };
};

#include "aX_Switch.hpp"

namespace Aegis {
    namespace X {
        
        class Mode {
            friend class Aegis::X::Switch;
            
            protected:
                Aegis::X::Switch & Parent;
                
                virtual bool Entry() = 0; // should return TRUE to be accepted
                virtual int  Loop(unsigned int t) = 0; // Switch::Loop return this
                virtual void Exit() = 0; 
                
            public:
                __fastcall Mode(Aegis::X::Switch & sw);
                __fastcall ~Mode();
        };
        
    };
};    

#endif

