/*
  Name: aX_Switch.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - X (eXecution) Subsystem - Mode Switcher class
*/

#include "aX_Switch.hpp"

__fastcall Aegis::X::Switch::Switch() {
    this->current = 0xFFFFFFFF;
    
    return;
};

__fastcall Aegis::X::Switch::~Switch() {
    if (this->current != 0xFFFFFFFF)
        this->modes[this->current]->Exit();
    return;
};

__fastcall void Aegis::X::Switch::Set(unsigned int m) {
    if (m < this->modes.size()) {
        if (this->modes[m]->Entry()) {
            if (this->current != 0xFFFFFFFF)
                this->modes[this->current]->Exit();
            this->current = m;
        };
    };
    return;
};

__fastcall unsigned int Aegis::X::Switch::Get() { return this->current; };


__fastcall bool Aegis::X::Switch::Call(unsigned int m) {
    if (m < this->modes.size()) {
        if (this->modes[m]->Entry()) {
            if (this->current != 0xFFFFFFFF) {
                this->call_stack.push(this->current);
                this->modes[this->current]->Exit();
            };
            
            this->current = m;
            return true;
        };
    };
    return false;
};

__fastcall void Aegis::X::Switch::Return() {
    unsigned int m = this->call_stack.top();
    
    if (m < this->modes.size()) {
        if (this->modes[m]->Entry()) {
            if (this->current != 0xFFFFFFFF)
                this->modes[this->current]->Exit();
            
            this->call_stack.pop();
            this->current = m;
        };
    };
    
    return;
};


__fastcall int Aegis::X::Switch::Loop(unsigned int t) {
    if (this->current != 0xFFFFFFFF)
        return this->modes[this->current]->Loop(t);
    else
        return -1;
};

__fastcall void Aegis::X::Switch::Reset() {
    if (this->current != 0xFFFFFFFF)
        this->modes[this->current]->Exit();

    this->modes.clear();
    return;
};

__fastcall unsigned int Aegis::X::Switch::Add(Aegis::X::Mode * m) {
    this->modes.push_back(m);
    return this->modes.size()-1;
};


