/*
  Name: aX_Switch.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - X (eXecution) Subsystem - Mode Switcher class
*/

#ifndef _AX_SWITCH_HPP
#define _AX_SWITCH_HPP

#include <vector>
#include <stack>

namespace Aegis {
    namespace X {
        class Switch;
    };
};

#include "aX_Mode.hpp"

namespace Aegis {
    namespace X {
        
        class Switch {
            private:
                unsigned int current;

                std::vector<Aegis::X::Mode*> modes;
                std::stack<unsigned int> call_stack;
            public:
                __fastcall Switch();
                __fastcall ~Switch();

                __fastcall void Set(unsigned int m);
                __fastcall void operator=(unsigned int m) { this->Set(m); };
                __fastcall unsigned int Get();

                __fastcall bool Call(unsigned int m);
                __fastcall void Return();
                
                __fastcall int Loop(unsigned int t);
                
                __fastcall void Reset();
                __fastcall unsigned int Add(Aegis::X::Mode*);
        };
        
    };
};    

#endif

