/*
  Name: aX_Timer.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - X (eXecution) Subsystem - Simple Timer
*/

#include "aX_Timer.hpp"

__fastcall Aegis::X::Timer::Timer() {
    this->Disable();
    this->SetDelay(1);
    this->Reset();
    
    return;
};

__fastcall Aegis::X::Timer::Timer(int delay) {
    this->Enable();
    this->SetDelay(delay);
    this->Reset();
    
    return;
};

__fastcall Aegis::X::Timer::~Timer() { };    

__fastcall void Aegis::X::Timer::Enable(bool en) {
    this->active = en;
    return;
};

__fastcall void Aegis::X::Timer::Reset() {
    this->time = 0;
};

__fastcall void Aegis::X::Timer::SetDelay(int delay) {
    this->delay = delay?:1;
    return;
};
    
__fastcall int Aegis::X::Timer::Check(int t) {
    if (!this->active) return 0;
    
    this->time += t;
    
    int val = this->time / this->delay;
    this->time %= this->delay;
    
    return val;
};

__fastcall float Aegis::X::Timer::Status() {
    float f = (float)this->time / (float)this->delay;
    if (f > 1.0f) f = 1.0f;
    
    return f;
};


